/* Prompt.c generated by valac 0.38.1, the Vala compiler
 * generated from Prompt.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "deja.h"
#include "widgets.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;

struct _Block6Data {
	int _ref_count_;
	GtkApplication* app;
};



GtkWindow* prompt (GtkApplication* app);
void show_prompt_notification (GtkApplication* app);
GtkWindow* show_prompt_dialog (GtkApplication* app);
gchar* get_header (void);
gchar* get_body (void);
gchar* get_cancel_button (gboolean mnemonics);
gchar* get_ok_button (gboolean mnemonics);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda40_ (Block6Data* _data6_, GtkDialog* dlg, gint resp);
static void ___lambda40__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);


GtkWindow* prompt (GtkApplication* app) {
	GtkWindow* result = NULL;
	DejaDupShellEnv _tmp0_;
	g_return_val_if_fail (app != NULL, NULL);
	deja_dup_update_prompt_time (FALSE);
	_tmp0_ = deja_dup_get_shell ();
	if (_tmp0_ == DEJA_DUP_SHELL_ENV_GNOME) {
		GtkApplication* _tmp1_;
		_tmp1_ = app;
		show_prompt_notification (_tmp1_);
		result = NULL;
		return result;
	} else {
		GtkApplication* _tmp2_;
		GtkWindow* _tmp3_;
		_tmp2_ = app;
		_tmp3_ = show_prompt_dialog (_tmp2_);
		result = _tmp3_;
		return result;
	}
}


gchar* get_header (void) {
	gchar* result = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup (_ ("Keep your files safe by backing up regularly"));
	result = _tmp0_;
	return result;
}


gchar* get_body (void) {
	gchar* result = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup (_ ("Important documents, data, and settings can be protected by storing th" \
"em in a backup. In the case of a disaster, you would be able to recove" \
"r them from that backup."));
	result = _tmp0_;
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = old;
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = old;
		_tmp4_ = replacement;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (self);
		result = _tmp5_;
		return result;
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = old;
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		regex = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp12_ = regex;
		_tmp13_ = replacement;
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
		_tmp11_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp15_ = _tmp11_;
		_tmp11_ = NULL;
		result = _tmp15_;
		_g_free0 (_tmp11_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* get_cancel_button (gboolean mnemonics) {
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = g_strdup (_ ("_Don't Show Again"));
	rv = _tmp0_;
	_tmp1_ = mnemonics;
	if (!_tmp1_) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = rv;
		_tmp3_ = string_replace (_tmp2_, "_", "");
		_g_free0 (rv);
		rv = _tmp3_;
	}
	result = rv;
	return result;
}


gchar* get_ok_button (gboolean mnemonics) {
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = g_strdup (_ ("_Open Backup Settings"));
	rv = _tmp0_;
	_tmp1_ = mnemonics;
	if (!_tmp1_) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = rv;
		_tmp3_ = string_replace (_tmp2_, "_", "");
		_g_free0 (rv);
		rv = _tmp3_;
	}
	result = rv;
	return result;
}


void show_prompt_notification (GtkApplication* app) {
	GNotification* note = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GNotification* _tmp2_;
	GNotification* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GThemedIcon* _tmp6_;
	GThemedIcon* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkApplication* _tmp12_;
	g_return_if_fail (app != NULL);
	_tmp0_ = get_header ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_notification_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	note = _tmp3_;
	_tmp4_ = get_body ();
	_tmp5_ = _tmp4_;
	g_notification_set_body (note, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = (GThemedIcon*) g_themed_icon_new ("org.gnome.DejaDup");
	_tmp7_ = _tmp6_;
	g_notification_set_icon (note, (GIcon*) _tmp7_);
	_g_object_unref0 (_tmp7_);
	g_notification_set_default_action (note, "app.prompt-ok");
	_tmp8_ = get_cancel_button (FALSE);
	_tmp9_ = _tmp8_;
	g_notification_add_button (note, _tmp9_, "app.prompt-cancel");
	_g_free0 (_tmp9_);
	_tmp10_ = get_ok_button (FALSE);
	_tmp11_ = _tmp10_;
	g_notification_add_button (note, _tmp11_, "app.prompt-ok");
	_g_free0 (_tmp11_);
	_tmp12_ = app;
	g_application_send_notification ((GApplication*) _tmp12_, "prompt", note);
	_g_object_unref0 (note);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block6Data* block6_data_ref (Block6Data* _data6_) {
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void block6_data_unref (void * _userdata_) {
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		_g_object_unref0 (_data6_->app);
		g_slice_free (Block6Data, _data6_);
	}
}


static void __lambda40_ (Block6Data* _data6_, GtkDialog* dlg, gint resp) {
	gint _tmp0_;
	GtkDialog* _tmp4_;
	g_return_if_fail (dlg != NULL);
	_tmp0_ = resp;
	if (_tmp0_ == ((gint) GTK_RESPONSE_REJECT)) {
		GtkApplication* _tmp1_;
		_tmp1_ = _data6_->app;
		g_action_group_activate_action ((GActionGroup*) _tmp1_, "prompt-cancel", NULL);
	} else {
		gint _tmp2_;
		_tmp2_ = resp;
		if (_tmp2_ == ((gint) GTK_RESPONSE_ACCEPT)) {
			GtkApplication* _tmp3_;
			_tmp3_ = _data6_->app;
			g_action_group_activate_action ((GActionGroup*) _tmp3_, "prompt-ok", NULL);
		}
	}
	_tmp4_ = dlg;
	deja_dup_destroy_widget ((GtkWidget*) _tmp4_);
}


static void ___lambda40__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
	__lambda40_ (self, _sender, response_id);
}


GtkWindow* show_prompt_dialog (GtkApplication* app) {
	GtkWindow* result = NULL;
	Block6Data* _data6_;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkMessageDialog* dlg = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkMessageDialog* _tmp4_;
	GtkMessageDialog* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkImage* img = NULL;
	GtkImage* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	g_return_val_if_fail (app != NULL, NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_tmp0_ = app;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data6_->app);
	_data6_->app = _tmp1_;
	_tmp2_ = get_header ();
	_tmp3_ = _tmp2_;
	_tmp4_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, 0, GTK_MESSAGE_INFO, GTK_BUTTONS_NONE, "%s", _tmp3_);
	g_object_ref_sink (_tmp4_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	dlg = _tmp5_;
	_tmp6_ = get_body ();
	_tmp7_ = _tmp6_;
	gtk_message_dialog_format_secondary_text (dlg, "%s", _tmp7_);
	_g_free0 (_tmp7_);
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) dlg, FALSE);
	gtk_window_set_title ((GtkWindow*) dlg, _ ("Backups"));
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("org.gnome.DejaDup", GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp8_);
	img = _tmp8_;
	g_object_set ((GtkMisc*) img, "yalign", 0.0f, NULL);
	gtk_widget_show ((GtkWidget*) img);
	gtk_message_dialog_set_image (dlg, (GtkWidget*) img);
	_tmp9_ = get_cancel_button (TRUE);
	_tmp10_ = _tmp9_;
	_tmp11_ = get_ok_button (TRUE);
	_tmp12_ = _tmp11_;
	gtk_dialog_add_buttons ((GtkDialog*) dlg, _tmp10_, GTK_RESPONSE_REJECT, _tmp12_, GTK_RESPONSE_ACCEPT, NULL);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp10_);
	g_signal_connect_data ((GtkDialog*) dlg, "response", (GCallback) ___lambda40__gtk_dialog_response, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	deja_dup_show_background_window_for_shell ((GtkWindow*) dlg);
	result = (GtkWindow*) dlg;
	_g_object_unref0 (img);
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return result;
}



