/* StatusIcon.c generated by valac 0.38.1, the Vala compiler
 * generated from StatusIcon.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include "deja.h"
#include "widgets.h"
#include <glib/gi18n-lib.h>
#include <gio/gio.h>


#define TYPE_STATUS_ICON (status_icon_get_type ())
#define STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS_ICON, StatusIcon))
#define STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS_ICON, StatusIconClass))
#define IS_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS_ICON))
#define IS_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS_ICON))
#define STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS_ICON, StatusIconClass))

typedef struct _StatusIcon StatusIcon;
typedef struct _StatusIconClass StatusIconClass;
typedef struct _StatusIconPrivate StatusIconPrivate;
enum  {
	STATUS_ICON_DUMMY_PROPERTY,
	STATUS_ICON_WINDOW_PROPERTY,
	STATUS_ICON_OP_PROPERTY,
	STATUS_ICON_AUTOMATIC_PROPERTY,
	STATUS_ICON_SHOW_AUTOMATIC_PROGRESS_PROPERTY,
	STATUS_ICON_LAST_PROPERTY
};
static GParamSpec* status_icon_properties[STATUS_ICON_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SHELL_STATUS_ICON (shell_status_icon_get_type ())
#define SHELL_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHELL_STATUS_ICON, ShellStatusIcon))
#define SHELL_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHELL_STATUS_ICON, ShellStatusIconClass))
#define IS_SHELL_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHELL_STATUS_ICON))
#define IS_SHELL_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHELL_STATUS_ICON))
#define SHELL_STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHELL_STATUS_ICON, ShellStatusIconClass))

typedef struct _ShellStatusIcon ShellStatusIcon;
typedef struct _ShellStatusIconClass ShellStatusIconClass;

#define TYPE_LEGACY_STATUS_ICON (legacy_status_icon_get_type ())
#define LEGACY_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LEGACY_STATUS_ICON, LegacyStatusIcon))
#define LEGACY_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LEGACY_STATUS_ICON, LegacyStatusIconClass))
#define IS_LEGACY_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LEGACY_STATUS_ICON))
#define IS_LEGACY_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LEGACY_STATUS_ICON))
#define LEGACY_STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LEGACY_STATUS_ICON, LegacyStatusIconClass))

typedef struct _LegacyStatusIcon LegacyStatusIcon;
typedef struct _LegacyStatusIconClass LegacyStatusIconClass;
enum  {
	STATUS_ICON_SHOW_WINDOW_SIGNAL,
	STATUS_ICON_LAST_SIGNAL
};
static guint status_icon_signals[STATUS_ICON_LAST_SIGNAL] = {0};
typedef struct _ShellStatusIconPrivate ShellStatusIconPrivate;
enum  {
	SHELL_STATUS_ICON_DUMMY_PROPERTY,
	SHELL_STATUS_ICON_LAST_PROPERTY
};
static GParamSpec* shell_status_icon_properties[SHELL_STATUS_ICON_LAST_PROPERTY];
typedef struct _LegacyStatusIconPrivate LegacyStatusIconPrivate;
enum  {
	LEGACY_STATUS_ICON_DUMMY_PROPERTY,
	LEGACY_STATUS_ICON_LAST_PROPERTY
};
static GParamSpec* legacy_status_icon_properties[LEGACY_STATUS_ICON_LAST_PROPERTY];

struct _StatusIcon {
	GObject parent_instance;
	StatusIconPrivate * priv;
	gchar* action;
	gdouble progress;
};

struct _StatusIconClass {
	GObjectClass parent_class;
	void (*done) (StatusIcon* self, gboolean success, gboolean cancelled, const gchar* detail);
	void (*update_progress) (StatusIcon* self);
};

struct _StatusIconPrivate {
	GtkWindow* _window;
	DejaDupOperation* _op;
	gboolean _automatic;
	gboolean _show_automatic_progress;
};

struct _ShellStatusIcon {
	StatusIcon parent_instance;
	ShellStatusIconPrivate * priv;
};

struct _ShellStatusIconClass {
	StatusIconClass parent_class;
};

struct _LegacyStatusIcon {
	StatusIcon parent_instance;
	LegacyStatusIconPrivate * priv;
};

struct _LegacyStatusIconClass {
	StatusIconClass parent_class;
};

struct _LegacyStatusIconPrivate {
	GtkStatusIcon* icon;
};


static gpointer status_icon_parent_class = NULL;
static gpointer shell_status_icon_parent_class = NULL;
static gpointer legacy_status_icon_parent_class = NULL;

GType status_icon_get_type (void) G_GNUC_CONST;
#define STATUS_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STATUS_ICON, StatusIconPrivate))
StatusIcon* status_icon_create (GtkWindow* window, DejaDupOperation* op, gboolean automatic);
ShellStatusIcon* shell_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic);
ShellStatusIcon* shell_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic);
GType shell_status_icon_get_type (void) G_GNUC_CONST;
LegacyStatusIcon* legacy_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic);
LegacyStatusIcon* legacy_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic);
GType legacy_status_icon_get_type (void) G_GNUC_CONST;
static void status_icon_set_action_desc (StatusIcon* self, DejaDupOperation* op, const gchar* action);
void status_icon_update_progress (StatusIcon* self);
static void status_icon_note_progress (StatusIcon* self, DejaDupOperation* op, gdouble progress);
void status_icon_done (StatusIcon* self, gboolean success, gboolean cancelled, const gchar* detail);
static void status_icon_real_done (StatusIcon* self, gboolean success, gboolean cancelled, const gchar* detail);
DejaDupOperation* status_icon_get_op (StatusIcon* self);
static void status_icon_real_update_progress (StatusIcon* self);
StatusIcon* status_icon_construct (GType object_type);
GtkWindow* status_icon_get_window (StatusIcon* self);
static void status_icon_set_window (StatusIcon* self, GtkWindow* value);
static void status_icon_set_op (StatusIcon* self, DejaDupOperation* value);
gboolean status_icon_get_automatic (StatusIcon* self);
static void status_icon_set_automatic (StatusIcon* self, gboolean value);
gboolean status_icon_get_show_automatic_progress (StatusIcon* self);
void status_icon_set_show_automatic_progress (StatusIcon* self, gboolean value);
static GObject * status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _status_icon_set_action_desc_deja_dup_operation_action_desc_changed (DejaDupOperation* _sender, const gchar* action, gpointer self);
static void _status_icon_note_progress_deja_dup_operation_progress (DejaDupOperation* _sender, gdouble percent, gpointer self);
static void status_icon_finalize (GObject * obj);
static void _vala_status_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_status_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static GObject * shell_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
#define LEGACY_STATUS_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LEGACY_STATUS_ICON, LegacyStatusIconPrivate))
static void legacy_status_icon_real_update_progress (StatusIcon* base);
static GObject * legacy_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _legacy_status_icon___lambda5_ (LegacyStatusIcon* self);
static void __legacy_status_icon___lambda5__gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self);
static void legacy_status_icon_finalize (GObject * obj);


StatusIcon* status_icon_create (GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	StatusIcon* result = NULL;
	StatusIcon* instance = NULL;
	DejaDupShellEnv _tmp0_;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (op != NULL, NULL);
	instance = NULL;
	_tmp0_ = deja_dup_get_shell ();
	switch (_tmp0_) {
		case DEJA_DUP_SHELL_ENV_GNOME:
		{
			GtkWindow* _tmp1_;
			DejaDupOperation* _tmp2_;
			gboolean _tmp3_;
			ShellStatusIcon* _tmp4_;
			_tmp1_ = window;
			_tmp2_ = op;
			_tmp3_ = automatic;
			_tmp4_ = shell_status_icon_new (_tmp1_, _tmp2_, _tmp3_);
			_g_object_unref0 (instance);
			instance = (StatusIcon*) _tmp4_;
			break;
		}
		default:
		{
			GtkWindow* _tmp5_;
			DejaDupOperation* _tmp6_;
			gboolean _tmp7_;
			LegacyStatusIcon* _tmp8_;
			_tmp5_ = window;
			_tmp6_ = op;
			_tmp7_ = automatic;
			_tmp8_ = legacy_status_icon_new (_tmp5_, _tmp6_, _tmp7_);
			_g_object_unref0 (instance);
			instance = (StatusIcon*) _tmp8_;
			break;
		}
	}
	result = instance;
	return result;
}


static void status_icon_set_action_desc (StatusIcon* self, DejaDupOperation* op, const gchar* action) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = action;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->action);
	self->action = _tmp1_;
	status_icon_update_progress (self);
}


static void status_icon_note_progress (StatusIcon* self, DejaDupOperation* op, gdouble progress) {
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	_tmp0_ = progress;
	self->progress = _tmp0_;
	status_icon_update_progress (self);
}


static void status_icon_real_done (StatusIcon* self, gboolean success, gboolean cancelled, const gchar* detail) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	_tmp2_ = success;
	if (_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = cancelled;
		_tmp1_ = !_tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		DejaDupOperation* _tmp4_;
		DejaDupToolJobMode _tmp5_;
		DejaDupToolJobMode _tmp6_;
		_tmp4_ = self->priv->_op;
		_tmp5_ = deja_dup_operation_get_mode (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* msg = NULL;
		gchar* _tmp7_;
		GNotificationPriority priority = 0;
		gchar* more = NULL;
		const gchar* _tmp8_;
		GNotification* note = NULL;
		const gchar* _tmp11_;
		GNotification* _tmp12_;
		const gchar* _tmp13_;
		GNotification* _tmp16_;
		GThemedIcon* _tmp17_;
		GThemedIcon* _tmp18_;
		GNotification* _tmp19_;
		GNotificationPriority _tmp20_;
		GNotification* _tmp21_;
		GApplication* _tmp22_;
		GNotification* _tmp23_;
		_tmp7_ = g_strdup (_ ("Backup completed"));
		msg = _tmp7_;
		priority = G_NOTIFICATION_PRIORITY_LOW;
		more = NULL;
		_tmp8_ = detail;
		if (_tmp8_ != NULL) {
			gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp9_ = g_strdup (_ ("Backup finished"));
			_g_free0 (msg);
			msg = _tmp9_;
			_tmp10_ = g_strdup (_ ("Not all files were successfully backed up.  See dialog for more detail" \
"s."));
			_g_free0 (more);
			more = _tmp10_;
			priority = G_NOTIFICATION_PRIORITY_NORMAL;
			g_signal_emit (self, status_icon_signals[STATUS_ICON_SHOW_WINDOW_SIGNAL], 0, FALSE);
		}
		_tmp11_ = msg;
		_tmp12_ = g_notification_new (_tmp11_);
		note = _tmp12_;
		_tmp13_ = more;
		if (_tmp13_ != NULL) {
			GNotification* _tmp14_;
			const gchar* _tmp15_;
			_tmp14_ = note;
			_tmp15_ = more;
			g_notification_set_body (_tmp14_, _tmp15_);
		}
		_tmp16_ = note;
		_tmp17_ = (GThemedIcon*) g_themed_icon_new ("org.gnome.DejaDup");
		_tmp18_ = _tmp17_;
		g_notification_set_icon (_tmp16_, (GIcon*) _tmp18_);
		_g_object_unref0 (_tmp18_);
		_tmp19_ = note;
		_tmp20_ = priority;
		g_notification_set_priority (_tmp19_, _tmp20_);
		_tmp21_ = note;
		g_notification_set_default_action (_tmp21_, "app.op-show");
		_tmp22_ = g_application_get_default ();
		_tmp23_ = note;
		g_application_send_notification (_tmp22_, "backup-status", _tmp23_);
		_g_object_unref0 (note);
		_g_free0 (more);
		_g_free0 (msg);
	} else {
		GApplication* _tmp24_;
		_tmp24_ = g_application_get_default ();
		g_application_withdraw_notification (_tmp24_, "backup-status");
	}
}


void status_icon_done (StatusIcon* self, gboolean success, gboolean cancelled, const gchar* detail) {
	g_return_if_fail (self != NULL);
	STATUS_ICON_GET_CLASS (self)->done (self, success, cancelled, detail);
}


static void status_icon_real_update_progress (StatusIcon* self) {
}


void status_icon_update_progress (StatusIcon* self) {
	g_return_if_fail (self != NULL);
	STATUS_ICON_GET_CLASS (self)->update_progress (self);
}


StatusIcon* status_icon_construct (GType object_type) {
	StatusIcon * self = NULL;
	self = (StatusIcon*) g_object_new (object_type, NULL);
	return self;
}


GtkWindow* status_icon_get_window (StatusIcon* self) {
	GtkWindow* result;
	GtkWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_window;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void status_icon_set_window (StatusIcon* self, GtkWindow* value) {
	g_return_if_fail (self != NULL);
	if (status_icon_get_window (self) != value) {
		GtkWindow* _tmp0_;
		GtkWindow* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_window);
		self->priv->_window = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, status_icon_properties[STATUS_ICON_WINDOW_PROPERTY]);
	}
}


DejaDupOperation* status_icon_get_op (StatusIcon* self) {
	DejaDupOperation* result;
	DejaDupOperation* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_op;
	result = _tmp0_;
	return result;
}


static void status_icon_set_op (StatusIcon* self, DejaDupOperation* value) {
	g_return_if_fail (self != NULL);
	if (status_icon_get_op (self) != value) {
		DejaDupOperation* _tmp0_;
		DejaDupOperation* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_op);
		self->priv->_op = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, status_icon_properties[STATUS_ICON_OP_PROPERTY]);
	}
}


gboolean status_icon_get_automatic (StatusIcon* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_automatic;
	result = _tmp0_;
	return result;
}


static void status_icon_set_automatic (StatusIcon* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (status_icon_get_automatic (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_automatic = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, status_icon_properties[STATUS_ICON_AUTOMATIC_PROPERTY]);
	}
}


gboolean status_icon_get_show_automatic_progress (StatusIcon* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_show_automatic_progress;
	result = _tmp0_;
	return result;
}


void status_icon_set_show_automatic_progress (StatusIcon* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (status_icon_get_show_automatic_progress (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_show_automatic_progress = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, status_icon_properties[STATUS_ICON_SHOW_AUTOMATIC_PROGRESS_PROPERTY]);
	}
}


static void _status_icon_set_action_desc_deja_dup_operation_action_desc_changed (DejaDupOperation* _sender, const gchar* action, gpointer self) {
	status_icon_set_action_desc ((StatusIcon*) self, _sender, action);
}


static void _status_icon_note_progress_deja_dup_operation_progress (DejaDupOperation* _sender, gdouble percent, gpointer self) {
	status_icon_note_progress ((StatusIcon*) self, _sender, percent);
}


static GObject * status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	StatusIcon * self;
	DejaDupOperation* _tmp0_;
	DejaDupOperation* _tmp1_;
	parent_class = G_OBJECT_CLASS (status_icon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATUS_ICON, StatusIcon);
	_tmp0_ = self->priv->_op;
	g_signal_connect_object (_tmp0_, "action-desc-changed", (GCallback) _status_icon_set_action_desc_deja_dup_operation_action_desc_changed, self, 0);
	_tmp1_ = self->priv->_op;
	g_signal_connect_object (_tmp1_, "progress", (GCallback) _status_icon_note_progress_deja_dup_operation_progress, self, 0);
	return obj;
}


static void status_icon_class_init (StatusIconClass * klass) {
	status_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StatusIconPrivate));
	((StatusIconClass *) klass)->done = (void (*) (StatusIcon *, gboolean, gboolean, const gchar*)) status_icon_real_done;
	((StatusIconClass *) klass)->update_progress = (void (*) (StatusIcon *)) status_icon_real_update_progress;
	G_OBJECT_CLASS (klass)->get_property = _vala_status_icon_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_status_icon_set_property;
	G_OBJECT_CLASS (klass)->constructor = status_icon_constructor;
	G_OBJECT_CLASS (klass)->finalize = status_icon_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_WINDOW_PROPERTY, status_icon_properties[STATUS_ICON_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", gtk_window_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_OP_PROPERTY, status_icon_properties[STATUS_ICON_OP_PROPERTY] = g_param_spec_object ("op", "op", "op", DEJA_DUP_TYPE_OPERATION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_AUTOMATIC_PROPERTY, status_icon_properties[STATUS_ICON_AUTOMATIC_PROPERTY] = g_param_spec_boolean ("automatic", "automatic", "automatic", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_SHOW_AUTOMATIC_PROGRESS_PROPERTY, status_icon_properties[STATUS_ICON_SHOW_AUTOMATIC_PROGRESS_PROPERTY] = g_param_spec_boolean ("show-automatic-progress", "show-automatic-progress", "show-automatic-progress", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	status_icon_signals[STATUS_ICON_SHOW_WINDOW_SIGNAL] = g_signal_new ("show-window", TYPE_STATUS_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}


static void status_icon_instance_init (StatusIcon * self) {
	self->priv = STATUS_ICON_GET_PRIVATE (self);
	self->priv->_automatic = FALSE;
	self->priv->_show_automatic_progress = FALSE;
}


static void status_icon_finalize (GObject * obj) {
	StatusIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATUS_ICON, StatusIcon);
	_g_object_unref0 (self->priv->_window);
	_g_object_unref0 (self->priv->_op);
	_g_free0 (self->action);
	G_OBJECT_CLASS (status_icon_parent_class)->finalize (obj);
}


/**
 * There are two modes for 'shell' integration:
 * 1) GNOME Shell
 * 2) Legacy
 * 
 * GNOME Shell:
 * No status icon at all.
 * Actions on persistent notifications.
 * Automatic-start and success notifications.
 * 
 * Legacy:
 * Standard GTK+ status icon.
 * Success notification.
 */
GType status_icon_get_type (void) {
	static volatile gsize status_icon_type_id__volatile = 0;
	if (g_once_init_enter (&status_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StatusIcon), 0, (GInstanceInitFunc) status_icon_instance_init, NULL };
		GType status_icon_type_id;
		status_icon_type_id = g_type_register_static (G_TYPE_OBJECT, "StatusIcon", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&status_icon_type_id__volatile, status_icon_type_id);
	}
	return status_icon_type_id__volatile;
}


static void _vala_status_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	StatusIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STATUS_ICON, StatusIcon);
	switch (property_id) {
		case STATUS_ICON_WINDOW_PROPERTY:
		g_value_set_object (value, status_icon_get_window (self));
		break;
		case STATUS_ICON_OP_PROPERTY:
		g_value_set_object (value, status_icon_get_op (self));
		break;
		case STATUS_ICON_AUTOMATIC_PROPERTY:
		g_value_set_boolean (value, status_icon_get_automatic (self));
		break;
		case STATUS_ICON_SHOW_AUTOMATIC_PROGRESS_PROPERTY:
		g_value_set_boolean (value, status_icon_get_show_automatic_progress (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_status_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	StatusIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STATUS_ICON, StatusIcon);
	switch (property_id) {
		case STATUS_ICON_WINDOW_PROPERTY:
		status_icon_set_window (self, g_value_get_object (value));
		break;
		case STATUS_ICON_OP_PROPERTY:
		status_icon_set_op (self, g_value_get_object (value));
		break;
		case STATUS_ICON_AUTOMATIC_PROPERTY:
		status_icon_set_automatic (self, g_value_get_boolean (value));
		break;
		case STATUS_ICON_SHOW_AUTOMATIC_PROGRESS_PROPERTY:
		status_icon_set_show_automatic_progress (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


ShellStatusIcon* shell_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	ShellStatusIcon * self = NULL;
	GtkWindow* _tmp0_;
	DejaDupOperation* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (op != NULL, NULL);
	_tmp0_ = window;
	_tmp1_ = op;
	_tmp2_ = automatic;
	self = (ShellStatusIcon*) g_object_new (object_type, "window", _tmp0_, "op", _tmp1_, "automatic", _tmp2_, NULL);
	return self;
}


ShellStatusIcon* shell_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	return shell_status_icon_construct (TYPE_SHELL_STATUS_ICON, window, op, automatic);
}


static GObject * shell_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ShellStatusIcon * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	parent_class = G_OBJECT_CLASS (shell_status_icon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SHELL_STATUS_ICON, ShellStatusIcon);
	_tmp1_ = status_icon_get_automatic ((StatusIcon*) self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		DejaDupOperation* _tmp3_;
		DejaDupOperation* _tmp4_;
		DejaDupToolJobMode _tmp5_;
		DejaDupToolJobMode _tmp6_;
		_tmp3_ = status_icon_get_op ((StatusIcon*) self);
		_tmp4_ = _tmp3_;
		_tmp5_ = deja_dup_operation_get_mode (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GNotification* note = NULL;
		GNotification* _tmp7_;
		GNotification* _tmp8_;
		GThemedIcon* _tmp9_;
		GThemedIcon* _tmp10_;
		GNotification* _tmp11_;
		GApplication* _tmp12_;
		GNotification* _tmp13_;
		_tmp7_ = g_notification_new (_ ("Starting scheduled backup"));
		note = _tmp7_;
		_tmp8_ = note;
		_tmp9_ = (GThemedIcon*) g_themed_icon_new ("org.gnome.DejaDup");
		_tmp10_ = _tmp9_;
		g_notification_set_icon (_tmp8_, (GIcon*) _tmp10_);
		_g_object_unref0 (_tmp10_);
		_tmp11_ = note;
		g_notification_set_default_action (_tmp11_, "app.op-show");
		_tmp12_ = g_application_get_default ();
		_tmp13_ = note;
		g_application_send_notification (_tmp12_, "backup-status", _tmp13_);
		_g_object_unref0 (note);
	}
	return obj;
}


static void shell_status_icon_class_init (ShellStatusIconClass * klass) {
	shell_status_icon_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = shell_status_icon_constructor;
}


static void shell_status_icon_instance_init (ShellStatusIcon * self) {
}


GType shell_status_icon_get_type (void) {
	static volatile gsize shell_status_icon_type_id__volatile = 0;
	if (g_once_init_enter (&shell_status_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ShellStatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) shell_status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ShellStatusIcon), 0, (GInstanceInitFunc) shell_status_icon_instance_init, NULL };
		GType shell_status_icon_type_id;
		shell_status_icon_type_id = g_type_register_static (TYPE_STATUS_ICON, "ShellStatusIcon", &g_define_type_info, 0);
		g_once_init_leave (&shell_status_icon_type_id__volatile, shell_status_icon_type_id);
	}
	return shell_status_icon_type_id__volatile;
}


LegacyStatusIcon* legacy_status_icon_construct (GType object_type, GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	LegacyStatusIcon * self = NULL;
	GtkWindow* _tmp0_;
	DejaDupOperation* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (op != NULL, NULL);
	_tmp0_ = window;
	_tmp1_ = op;
	_tmp2_ = automatic;
	self = (LegacyStatusIcon*) g_object_new (object_type, "window", _tmp0_, "op", _tmp1_, "automatic", _tmp2_, NULL);
	return self;
}


LegacyStatusIcon* legacy_status_icon_new (GtkWindow* window, DejaDupOperation* op, gboolean automatic) {
	return legacy_status_icon_construct (TYPE_LEGACY_STATUS_ICON, window, op, automatic);
}


static void legacy_status_icon_real_update_progress (StatusIcon* base) {
	LegacyStatusIcon * self;
	gchar* tooltip = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gdouble _tmp4_;
	GtkStatusIcon* _tmp12_;
	const gchar* _tmp13_;
	self = (LegacyStatusIcon*) base;
	_tmp0_ = g_strdup ("");
	tooltip = _tmp0_;
	_tmp1_ = ((StatusIcon*) self)->action;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = ((StatusIcon*) self)->action;
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (tooltip);
		tooltip = _tmp3_;
	}
	_tmp4_ = ((StatusIcon*) self)->progress;
	if (_tmp4_ > ((gdouble) 0)) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gdouble _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp5_ = tooltip;
		_tmp6_ = g_strconcat (_tmp5_, "\n", NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = ((StatusIcon*) self)->progress;
		_tmp9_ = g_strdup_printf (_ ("%.1f%% complete"), _tmp8_ * 100);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
		_g_free0 (tooltip);
		tooltip = _tmp11_;
		_g_free0 (_tmp10_);
		_g_free0 (_tmp7_);
	}
	_tmp12_ = self->priv->icon;
	_tmp13_ = tooltip;
	gtk_status_icon_set_tooltip_text (_tmp12_, _tmp13_);
	_g_free0 (tooltip);
}


static void _legacy_status_icon___lambda5_ (LegacyStatusIcon* self) {
	g_signal_emit ((StatusIcon*) self, status_icon_signals[STATUS_ICON_SHOW_WINDOW_SIGNAL], 0, TRUE);
}


static void __legacy_status_icon___lambda5__gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self) {
	_legacy_status_icon___lambda5_ ((LegacyStatusIcon*) self);
}


static GObject * legacy_status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	LegacyStatusIcon * self;
	GtkStatusIcon* _tmp0_;
	GtkStatusIcon* _tmp1_;
	GtkStatusIcon* _tmp2_;
	const gchar* _tmp3_;
	GtkStatusIcon* _tmp4_;
	parent_class = G_OBJECT_CLASS (legacy_status_icon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LEGACY_STATUS_ICON, LegacyStatusIcon);
	_tmp0_ = gtk_status_icon_new ();
	_g_object_unref0 (self->priv->icon);
	self->priv->icon = _tmp0_;
	_tmp1_ = self->priv->icon;
	g_object_set (_tmp1_, "icon-name", "org.gnome.DejaDup", NULL);
	_tmp2_ = self->priv->icon;
	_tmp3_ = g_get_application_name ();
	gtk_status_icon_set_title (_tmp2_, _tmp3_);
	_tmp4_ = self->priv->icon;
	g_signal_connect_object (_tmp4_, "activate", (GCallback) __legacy_status_icon___lambda5__gtk_status_icon_activate, self, 0);
	status_icon_update_progress ((StatusIcon*) self);
	return obj;
}


static void legacy_status_icon_class_init (LegacyStatusIconClass * klass) {
	legacy_status_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (LegacyStatusIconPrivate));
	((StatusIconClass *) klass)->update_progress = (void (*) (StatusIcon *)) legacy_status_icon_real_update_progress;
	G_OBJECT_CLASS (klass)->constructor = legacy_status_icon_constructor;
	G_OBJECT_CLASS (klass)->finalize = legacy_status_icon_finalize;
}


static void legacy_status_icon_instance_init (LegacyStatusIcon * self) {
	self->priv = LEGACY_STATUS_ICON_GET_PRIVATE (self);
}


static void legacy_status_icon_finalize (GObject * obj) {
	LegacyStatusIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LEGACY_STATUS_ICON, LegacyStatusIcon);
	_g_object_unref0 (self->priv->icon);
	G_OBJECT_CLASS (legacy_status_icon_parent_class)->finalize (obj);
}


GType legacy_status_icon_get_type (void) {
	static volatile gsize legacy_status_icon_type_id__volatile = 0;
	if (g_once_init_enter (&legacy_status_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LegacyStatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) legacy_status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LegacyStatusIcon), 0, (GInstanceInitFunc) legacy_status_icon_instance_init, NULL };
		GType legacy_status_icon_type_id;
		legacy_status_icon_type_id = g_type_register_static (TYPE_STATUS_ICON, "LegacyStatusIcon", &g_define_type_info, 0);
		g_once_init_leave (&legacy_status_icon_type_id__volatile, legacy_status_icon_type_id);
	}
	return legacy_status_icon_type_id__volatile;
}



