/* monitor.c generated by valac 0.38.1, the Vala compiler
 * generated from monitor.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include "deja.h"
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_MONITOR (monitor_get_type ())
#define MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITOR, Monitor))
#define MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MONITOR, MonitorClass))
#define IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITOR))
#define IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MONITOR))
#define MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MONITOR, MonitorClass))

typedef struct _Monitor Monitor;
typedef struct _MonitorClass MonitorClass;
typedef struct _MonitorPrivate MonitorPrivate;
enum  {
	MONITOR_DUMMY_PROPERTY,
	MONITOR_LAST_PROPERTY
};
static GParamSpec* monitor_properties[MONITOR_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MonitorIsReadyData MonitorIsReadyData;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MonitorKickoffData MonitorKickoffData;
typedef struct _Block1Data Block1Data;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))

struct _Monitor {
	GObject parent_instance;
	MonitorPrivate * priv;
};

struct _MonitorClass {
	GObjectClass parent_class;
};

struct _MonitorIsReadyData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* when;
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gchar* _tmp3_;
	DejaDupBackend* backend;
	DejaDupBackend* _tmp4_;
	DejaDupNetwork* network;
	DejaDupNetwork* _tmp5_;
	gboolean _tmp6_;
	DejaDupBackend* _tmp7_;
	gboolean _tmp8_;
	DejaDupNetwork* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_;
	DejaDupBackend* _tmp14_;
	gboolean _tmp15_;
	DejaDupNetwork* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	gchar* _tmp19_;
	DejaDupBackend* _tmp20_;
	gchar* _tmp21_;
	gboolean _tmp22_;
};

struct _MonitorKickoffData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GTimeSpan wait_time;
	GTimeSpan _tmp0_;
	gboolean _tmp1_;
	GTimeSpan _tmp2_;
	gboolean was_reactive;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gchar* when;
	gboolean ready;
	gchar* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* command;
	gchar* _tmp12_;
	gchar** argv;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint argv_length1;
	gint _argv_size_;
	gboolean _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	GError* e;
	GError* _tmp18_;
	const gchar* _tmp19_;
	GError * _inner_error_;
};

struct _Block1Data {
	int _ref_count_;
	GMainLoop* loop;
};


static gpointer monitor_parent_class = NULL;
static guint monitor_timeout_id;
static guint monitor_timeout_id = 0U;
static guint monitor_netcheck_id;
static guint monitor_netcheck_id = 0U;
static gboolean monitor_reactive_check;
static gboolean monitor_reactive_check = FALSE;
static gboolean monitor_first_check;
static gboolean monitor_first_check = FALSE;
static DejaDupFilteredSettings* monitor_settings;
static DejaDupFilteredSettings* monitor_settings = NULL;
static gboolean monitor_testing_delay;
static gboolean monitor_testing_delay = TRUE;
static gboolean monitor_show_version;
static gboolean monitor_show_version = FALSE;

GType monitor_get_type (void) G_GNUC_CONST;
static gboolean monitor_valid_network (void);
static gboolean monitor_network_check (void);
static void monitor_prepare_next_run (void);
static void monitor_network_changed (void);
static gboolean _monitor_network_check_gsource_func (gpointer self);
static void monitor_volume_added (GVolumeMonitor* vm, GVolume* vol);
static void monitor_is_ready_data_free (gpointer _data);
static void monitor_is_ready (GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean monitor_is_ready_finish (GAsyncResult* _res_, gchar* * when);
static gboolean monitor_is_ready_co (MonitorIsReadyData* _data_);
static void monitor_is_ready_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean monitor_handle_options (gint* status);
static GTimeSpan monitor_time_until (GDateTime* date);
static void monitor_notify_delay (const gchar* reason);
static void _vala_array_add1 (gchar** * array, int* length, int* size, gchar* value);
static void monitor_kickoff_data_free (gpointer _data);
static void monitor_kickoff (GAsyncReadyCallback _callback_, gpointer _user_data_);
static void monitor_kickoff_finish (GAsyncResult* _res_);
static gboolean monitor_kickoff_co (MonitorKickoffData* _data_);
static gboolean monitor_time_until_next_run (GTimeSpan* time);
static void monitor_prepare_tomorrow (void);
static void monitor_kickoff_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void monitor_prepare_run (GTimeSpan wait_time);
static gboolean ___lambda4_ (void);
static gboolean ____lambda4__gsource_func (gpointer self);
static void monitor_prepare_if_necessary (const gchar* key);
static void monitor_make_first_check (void);
static gboolean __lambda5_ (void);
static gboolean ___lambda5__gsource_func (gpointer self);
static void monitor_watch_settings (void);
static void _monitor_prepare_if_necessary_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
static void monitor_begin_monitoring (void);
static void _monitor_network_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _monitor_volume_added_g_volume_monitor_volume_added (GVolumeMonitor* _sender, GVolume* volume, gpointer self);
static gboolean ___lambda6_ (void);
static gboolean ____lambda6__gsource_func (gpointer self);
static gint monitor_main (gchar** args, int args_length1);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block1Data* _data1_);
static void __lambda8_ (void);
static void ___lambda8__gbus_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void __lambda9_ (void);
static void ___lambda9__gbus_name_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void __lambda10_ (Block1Data* _data1_);
static void ___lambda10__gbus_name_lost_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static gboolean ___lambda7__gsource_func (gpointer self);
Monitor* monitor_new (void);
Monitor* monitor_construct (GType object_type);
static void monitor_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GOptionEntry MONITOR_options[2] = {{"version", (gchar) 0, 0, G_OPTION_ARG_NONE, &monitor_show_version, N_ ("Show version"), NULL}, {NULL}};

static gboolean monitor_valid_network (void) {
	gboolean result = FALSE;
	DejaDupNetwork* network = NULL;
	DejaDupNetwork* _tmp0_;
	gboolean _tmp1_ = FALSE;
	DejaDupNetwork* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	_tmp0_ = deja_dup_network_get ();
	network = _tmp0_;
	_tmp2_ = network;
	_tmp3_ = deja_dup_network_get_connected (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		DejaDupNetwork* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = network;
		_tmp6_ = deja_dup_network_get_metered (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp1_ = !_tmp7_;
	} else {
		_tmp1_ = FALSE;
	}
	result = _tmp1_;
	_g_object_unref0 (network);
	return result;
}


static gboolean monitor_network_check (void) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	monitor_reactive_check = TRUE;
	_tmp0_ = monitor_valid_network ();
	if (_tmp0_) {
		monitor_prepare_next_run ();
	}
	monitor_reactive_check = FALSE;
	result = FALSE;
	return result;
}


static gboolean _monitor_network_check_gsource_func (gpointer self) {
	gboolean result;
	result = monitor_network_check ();
	return result;
}


static void monitor_network_changed (void) {
	guint _tmp0_;
	gboolean _tmp2_;
	_tmp0_ = monitor_netcheck_id;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = monitor_netcheck_id;
		g_source_remove (_tmp1_);
	}
	monitor_netcheck_id = (guint) 0;
	_tmp2_ = monitor_valid_network ();
	if (_tmp2_) {
		guint _tmp3_;
		_tmp3_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 120, _monitor_network_check_gsource_func, NULL, NULL);
		monitor_netcheck_id = _tmp3_;
	}
}


static void monitor_volume_added (GVolumeMonitor* vm, GVolume* vol) {
	g_return_if_fail (vm != NULL);
	g_return_if_fail (vol != NULL);
	monitor_reactive_check = TRUE;
	monitor_prepare_next_run ();
	monitor_reactive_check = FALSE;
}


static void monitor_is_ready_data_free (gpointer _data) {
	MonitorIsReadyData* _data_;
	_data_ = _data;
	g_slice_free (MonitorIsReadyData, _data_);
}


static void monitor_is_ready (GAsyncReadyCallback _callback_, gpointer _user_data_) {
	MonitorIsReadyData* _data_;
	_data_ = g_slice_new0 (MonitorIsReadyData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, monitor_is_ready_data_free);
	monitor_is_ready_co (_data_);
}


static gboolean monitor_is_ready_finish (GAsyncResult* _res_, gchar* * when) {
	gboolean result;
	MonitorIsReadyData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	if (when) {
		*when = _data_->when;
	} else {
		_g_free0 (_data_->when);
	}
	_data_->when = NULL;
	result = _data_->result;
	return result;
}


static void monitor_is_ready_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	MonitorIsReadyData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	monitor_is_ready_co (_data_);
}


static gboolean monitor_is_ready_co (MonitorIsReadyData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp1_ = deja_dup_in_testing_mode ();
	if (_data_->_tmp1_) {
		_data_->_tmp2_ = monitor_testing_delay;
		_data_->_tmp0_ = _data_->_tmp2_;
	} else {
		_data_->_tmp0_ = FALSE;
	}
	if (_data_->_tmp0_) {
		monitor_testing_delay = FALSE;
		_data_->_tmp3_ = g_strdup ("Testing");
		_g_free0 (_data_->when);
		_data_->when = _data_->_tmp3_;
		_data_->result = FALSE;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (g_task_get_completed (_data_->_async_result) != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp4_ = deja_dup_backend_get_default ();
	_data_->backend = _data_->_tmp4_;
	_data_->_tmp5_ = deja_dup_network_get ();
	_data_->network = _data_->_tmp5_;
	_data_->_tmp7_ = _data_->backend;
	_data_->_tmp8_ = deja_dup_backend_is_native (_data_->_tmp7_);
	if (!_data_->_tmp8_) {
		_data_->_tmp9_ = _data_->network;
		_data_->_tmp10_ = deja_dup_network_get_connected (_data_->_tmp9_);
		_data_->_tmp11_ = _data_->_tmp10_;
		_data_->_tmp6_ = !_data_->_tmp11_;
	} else {
		_data_->_tmp6_ = FALSE;
	}
	if (_data_->_tmp6_) {
		_data_->_tmp12_ = g_strdup (_ ("Backup will begin when a network connection becomes available."));
		_g_free0 (_data_->when);
		_data_->when = _data_->_tmp12_;
		_data_->result = FALSE;
		_g_object_unref0 (_data_->network);
		_g_object_unref0 (_data_->backend);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (g_task_get_completed (_data_->_async_result) != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	} else {
		_data_->_tmp14_ = _data_->backend;
		_data_->_tmp15_ = deja_dup_backend_is_native (_data_->_tmp14_);
		if (!_data_->_tmp15_) {
			_data_->_tmp16_ = _data_->network;
			_data_->_tmp17_ = deja_dup_network_get_metered (_data_->_tmp16_);
			_data_->_tmp18_ = _data_->_tmp17_;
			_data_->_tmp13_ = _data_->_tmp18_;
		} else {
			_data_->_tmp13_ = FALSE;
		}
		if (_data_->_tmp13_) {
			_data_->_tmp19_ = g_strdup (_ ("Backup will begin when an unmetered network connection becomes availab" \
"le."));
			_g_free0 (_data_->when);
			_data_->when = _data_->_tmp19_;
			_data_->result = FALSE;
			_g_object_unref0 (_data_->network);
			_g_object_unref0 (_data_->backend);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (g_task_get_completed (_data_->_async_result) != TRUE) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp20_ = _data_->backend;
	_data_->_tmp21_ = NULL;
	_data_->_state_ = 1;
	deja_dup_backend_is_ready (_data_->_tmp20_, monitor_is_ready_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp22_ = deja_dup_backend_is_ready_finish (_data_->_tmp20_, _data_->_res_, &_data_->_tmp21_);
	_g_free0 (_data_->when);
	_data_->when = _data_->_tmp21_;
	_data_->result = _data_->_tmp22_;
	_g_object_unref0 (_data_->network);
	_g_object_unref0 (_data_->backend);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static gboolean monitor_handle_options (gint* status) {
	gint _vala_status = 0;
	gboolean result = FALSE;
	gboolean _tmp0_;
	_vala_status = 0;
	_tmp0_ = monitor_show_version;
	if (_tmp0_) {
		g_print ("%s %s\n", "deja-dup-monitor", VERSION);
		result = FALSE;
		if (status) {
			*status = _vala_status;
		}
		return result;
	}
	result = TRUE;
	if (status) {
		*status = _vala_status;
	}
	return result;
}


static GTimeSpan monitor_time_until (GDateTime* date) {
	GTimeSpan result = 0LL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GTimeSpan _tmp3_;
	GTimeSpan _tmp4_;
	g_return_val_if_fail (date != NULL, 0LL);
	_tmp0_ = date;
	_tmp1_ = g_date_time_new_now_local ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_date_time_difference (_tmp0_, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_date_time_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static void _vala_array_add1 (gchar** * array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void monitor_notify_delay (const gchar* reason) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (reason != NULL);
	{
		gchar* command = NULL;
		gchar* _tmp0_;
		gchar** argv = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint argv_length1;
		gint _argv_size_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		_tmp0_ = deja_dup_nice_prefix ("deja-dup --delay");
		command = _tmp0_;
		_tmp2_ = _tmp1_ = g_strsplit (command, " ", 0);
		argv = _tmp2_;
		argv_length1 = _vala_array_length (_tmp1_);
		_argv_size_ = argv_length1;
		_tmp3_ = argv;
		_tmp3__length1 = argv_length1;
		_tmp4_ = reason;
		_tmp5_ = g_strdup (_tmp4_);
		_vala_array_add1 (&argv, &argv_length1, &_argv_size_, _tmp5_);
		_tmp6_ = argv;
		_tmp6__length1 = argv_length1;
		g_spawn_async (NULL, _tmp6_, NULL, (G_SPAWN_SEARCH_PATH | G_SPAWN_STDOUT_TO_DEV_NULL) | G_SPAWN_STDERR_TO_DEV_NULL, NULL, NULL, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (command);
			goto __catch0_g_error;
		}
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (command);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_warning ("monitor.vala:122: %s\n", _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void monitor_kickoff_data_free (gpointer _data) {
	MonitorKickoffData* _data_;
	_data_ = _data;
	g_slice_free (MonitorKickoffData, _data_);
}


static void monitor_kickoff (GAsyncReadyCallback _callback_, gpointer _user_data_) {
	MonitorKickoffData* _data_;
	_data_ = g_slice_new0 (MonitorKickoffData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, monitor_kickoff_data_free);
	monitor_kickoff_co (_data_);
}


static void monitor_kickoff_finish (GAsyncResult* _res_) {
	MonitorKickoffData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static void monitor_kickoff_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	MonitorKickoffData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	monitor_kickoff_co (_data_);
}


static gboolean monitor_kickoff_co (MonitorKickoffData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = 0LL;
	_data_->_tmp1_ = monitor_time_until_next_run (&_data_->_tmp0_);
	_data_->wait_time = _data_->_tmp0_;
	if (!_data_->_tmp1_) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (g_task_get_completed (_data_->_async_result) != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp2_ = _data_->wait_time;
	if (_data_->_tmp2_ > ((GTimeSpan) 0)) {
		monitor_prepare_next_run ();
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (g_task_get_completed (_data_->_async_result) != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp3_ = monitor_reactive_check;
	_data_->was_reactive = _data_->_tmp3_;
	_data_->_tmp4_ = _data_->was_reactive;
	if (!_data_->_tmp4_) {
		monitor_prepare_tomorrow ();
	}
	_data_->_tmp5_ = NULL;
	_data_->_state_ = 1;
	monitor_is_ready (monitor_kickoff_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp6_ = monitor_is_ready_finish (_data_->_res_, &_data_->_tmp5_);
	_g_free0 (_data_->when);
	_data_->when = _data_->_tmp5_;
	_data_->ready = _data_->_tmp6_;
	_data_->_tmp7_ = _data_->ready;
	if (!_data_->_tmp7_) {
		g_debug ("monitor.vala:151: Postponing the backup.");
		_data_->_tmp9_ = _data_->was_reactive;
		if (!_data_->_tmp9_) {
			_data_->_tmp10_ = _data_->when;
			_data_->_tmp8_ = _data_->_tmp10_ != NULL;
		} else {
			_data_->_tmp8_ = FALSE;
		}
		if (_data_->_tmp8_) {
			_data_->_tmp11_ = _data_->when;
			monitor_notify_delay (_data_->_tmp11_);
		}
		_g_free0 (_data_->when);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (g_task_get_completed (_data_->_async_result) != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	{
		g_debug ("monitor.vala:158: Running automatic backup.");
		_data_->_tmp12_ = deja_dup_nice_prefix ("deja-dup --backup --auto");
		_data_->command = _data_->_tmp12_;
		_data_->_tmp13_ = _data_->command;
		_data_->_tmp15_ = _data_->_tmp14_ = g_strsplit (_data_->_tmp13_, " ", 0);
		_data_->argv = _data_->_tmp15_;
		_data_->argv_length1 = _vala_array_length (_data_->_tmp14_);
		_data_->_argv_size_ = _data_->argv_length1;
		_data_->_tmp16_ = deja_dup_in_testing_mode ();
		if (_data_->_tmp16_) {
			deja_dup_update_last_run_timestamp (DEJA_DUP_TIMESTAMP_TYPE_BACKUP);
		} else {
			_data_->_tmp17_ = _data_->argv;
			_data_->_tmp17__length1 = _data_->argv_length1;
			g_spawn_async (NULL, _data_->_tmp17_, NULL, (G_SPAWN_SEARCH_PATH | G_SPAWN_STDOUT_TO_DEV_NULL) | G_SPAWN_STDERR_TO_DEV_NULL, NULL, NULL, NULL, &_data_->_inner_error_);
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
				_data_->argv = (_vala_array_free (_data_->argv, _data_->argv_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (_data_->command);
				goto __catch1_g_error;
			}
		}
		_data_->argv = (_vala_array_free (_data_->argv, _data_->argv_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (_data_->command);
	}
	goto __finally1;
	__catch1_g_error:
	{
		_data_->e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp18_ = _data_->e;
		_data_->_tmp19_ = _data_->_tmp18_->message;
		g_warning ("monitor.vala:175: %s\n", _data_->_tmp19_);
		_g_error_free0 (_data_->e);
	}
	__finally1:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		_g_free0 (_data_->when);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_free0 (_data_->when);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static gboolean monitor_time_until_next_run (GTimeSpan* time) {
	GTimeSpan _vala_time = 0LL;
	gboolean result = FALSE;
	GDateTime* next_date = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GTimeSpan _tmp3_;
	_vala_time = (GTimeSpan) 0;
	_tmp0_ = deja_dup_next_run_date ();
	next_date = _tmp0_;
	_tmp1_ = next_date;
	if (_tmp1_ == NULL) {
		g_debug ("monitor.vala:185: Automatic backups disabled.  Not scheduling a backup" \
".");
		result = FALSE;
		_g_date_time_unref0 (next_date);
		if (time) {
			*time = _vala_time;
		}
		return result;
	}
	_tmp2_ = next_date;
	_tmp3_ = monitor_time_until (_tmp2_);
	_vala_time = _tmp3_;
	result = TRUE;
	_g_date_time_unref0 (next_date);
	if (time) {
		*time = _vala_time;
	}
	return result;
}


static gboolean ___lambda4_ (void) {
	gboolean result = FALSE;
	monitor_kickoff (NULL, NULL);
	monitor_timeout_id = (guint) 0;
	result = FALSE;
	return result;
}


static gboolean ____lambda4__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda4_ ();
	return result;
}


static void monitor_prepare_run (GTimeSpan wait_time) {
	guint _tmp0_;
	GTimeSpan secs = 0LL;
	GTimeSpan _tmp2_;
	gboolean _tmp3_ = FALSE;
	GTimeSpan _tmp4_;
	_tmp0_ = monitor_timeout_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = monitor_timeout_id;
		g_source_remove (_tmp1_);
		monitor_timeout_id = (guint) 0;
	}
	_tmp2_ = wait_time;
	secs = (_tmp2_ / G_TIME_SPAN_SECOND) + 1;
	_tmp4_ = wait_time;
	if (_tmp4_ > ((GTimeSpan) 0)) {
		GTimeSpan _tmp5_;
		_tmp5_ = secs;
		_tmp3_ = _tmp5_ > ((GTimeSpan) 0);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GTimeSpan _tmp6_;
		GTimeSpan _tmp7_;
		guint _tmp8_;
		_tmp6_ = secs;
		g_debug ("monitor.vala:203: Waiting %ld seconds until next backup.", (glong) _tmp6_);
		_tmp7_ = secs;
		_tmp8_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) _tmp7_, ____lambda4__gsource_func, NULL, NULL);
		monitor_timeout_id = _tmp8_;
	} else {
		GTimeSpan _tmp9_;
		_tmp9_ = secs;
		g_debug ("monitor.vala:211: Late by %ld seconds.  Backing up now.", (glong) (_tmp9_ * -1));
		monitor_kickoff (NULL, NULL);
	}
}


static void monitor_prepare_tomorrow (void) {
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GDateTime* tomorrow = NULL;
	GTimeSpan _tmp1_;
	GDateTime* _tmp2_;
	GTimeSpan time = 0LL;
	GTimeSpan _tmp3_;
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = deja_dup_get_day ();
	_tmp2_ = g_date_time_add (now, _tmp1_);
	tomorrow = _tmp2_;
	_tmp3_ = monitor_time_until (tomorrow);
	time = _tmp3_;
	monitor_prepare_run (time);
	_g_date_time_unref0 (tomorrow);
	_g_date_time_unref0 (now);
}


static void monitor_prepare_next_run (void) {
	gboolean _tmp0_;
	GTimeSpan wait_time = 0LL;
	GTimeSpan _tmp1_ = 0LL;
	gboolean _tmp2_;
	GTimeSpan _tmp3_;
	_tmp0_ = monitor_first_check;
	if (!_tmp0_) {
		return;
	}
	_tmp2_ = monitor_time_until_next_run (&_tmp1_);
	wait_time = _tmp1_;
	if (!_tmp2_) {
		return;
	}
	_tmp3_ = wait_time;
	monitor_prepare_run (_tmp3_);
}


static void monitor_prepare_if_necessary (const gchar* key) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	g_return_if_fail (key != NULL);
	_tmp2_ = key;
	if (g_strcmp0 (_tmp2_, DEJA_DUP_LAST_BACKUP_KEY) == 0) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp3_;
		_tmp3_ = key;
		_tmp1_ = g_strcmp0 (_tmp3_, DEJA_DUP_PERIODIC_KEY) == 0;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp4_;
		_tmp4_ = key;
		_tmp0_ = g_strcmp0 (_tmp4_, DEJA_DUP_PERIODIC_PERIOD_KEY) == 0;
	}
	if (_tmp0_) {
		monitor_prepare_next_run ();
	}
}


static gboolean __lambda5_ (void) {
	gboolean result = FALSE;
	deja_dup_make_prompt_check ();
	result = TRUE;
	return result;
}


static gboolean ___lambda5__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda5_ ();
	return result;
}


static void monitor_make_first_check (void) {
	gint _tmp0_;
	monitor_first_check = TRUE;
	deja_dup_make_prompt_check ();
	_tmp0_ = deja_dup_get_prompt_delay ();
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) _tmp0_, ___lambda5__gsource_func, NULL, NULL);
	monitor_prepare_next_run ();
}


static void _monitor_prepare_if_necessary_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	monitor_prepare_if_necessary (key);
}


static void monitor_watch_settings (void) {
	DejaDupFilteredSettings* _tmp0_;
	DejaDupFilteredSettings* _tmp1_;
	_tmp0_ = deja_dup_get_settings (NULL);
	_g_object_unref0 (monitor_settings);
	monitor_settings = _tmp0_;
	_tmp1_ = monitor_settings;
	g_signal_connect ((GSettings*) _tmp1_, "changed", (GCallback) _monitor_prepare_if_necessary_g_settings_changed, NULL);
}


static void _monitor_network_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	monitor_network_changed ();
}


static void _monitor_volume_added_g_volume_monitor_volume_added (GVolumeMonitor* _sender, GVolume* volume, gpointer self) {
	monitor_volume_added (_sender, volume);
}


static gboolean ___lambda6_ (void) {
	gboolean result = FALSE;
	monitor_make_first_check ();
	result = FALSE;
	return result;
}


static gboolean ____lambda6__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda6_ ();
	return result;
}


static void monitor_begin_monitoring (void) {
	DejaDupNetwork* _tmp0_;
	DejaDupNetwork* _tmp1_;
	DejaDupNetwork* _tmp2_;
	DejaDupNetwork* _tmp3_;
	GVolumeMonitor* mon = NULL;
	GVolumeMonitor* _tmp4_;
	GVolumeMonitor* _tmp5_;
	GVolumeMonitor* _tmp6_;
	gboolean _tmp7_;
	_tmp0_ = deja_dup_network_get ();
	_tmp1_ = _tmp0_;
	g_signal_connect ((GObject*) _tmp1_, "notify::connected", (GCallback) _monitor_network_changed_g_object_notify, NULL);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = deja_dup_network_get ();
	_tmp3_ = _tmp2_;
	g_signal_connect ((GObject*) _tmp3_, "notify::metered", (GCallback) _monitor_network_changed_g_object_notify, NULL);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = g_volume_monitor_get ();
	mon = _tmp4_;
	_tmp5_ = mon;
	g_object_ref ((GObject*) _tmp5_);
	_tmp6_ = mon;
	g_signal_connect (_tmp6_, "volume-added", (GCallback) _monitor_volume_added_g_volume_monitor_volume_added, NULL);
	monitor_watch_settings ();
	_tmp7_ = deja_dup_in_testing_mode ();
	if (_tmp7_) {
		monitor_make_first_check ();
	} else {
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 120, ____lambda6__gsource_func, NULL, NULL);
	}
	_g_object_unref0 (mon);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_main_loop_unref0 (_data1_->loop);
		g_slice_free (Block1Data, _data1_);
	}
}


static void __lambda8_ (void) {
}


static void ___lambda8__gbus_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	__lambda8_ ();
}


static void __lambda9_ (void) {
	monitor_begin_monitoring ();
}


static void ___lambda9__gbus_name_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	__lambda9_ ();
}


static void __lambda10_ (Block1Data* _data1_) {
	GMainLoop* _tmp0_;
	_tmp0_ = _data1_->loop;
	g_main_loop_quit (_tmp0_);
}


static void ___lambda10__gbus_name_lost_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	__lambda10_ (self);
}


static gboolean __lambda7_ (Block1Data* _data1_) {
	gboolean result = FALSE;
	g_bus_own_name_with_closures (G_BUS_TYPE_SESSION, "org.gnome.DejaDup.Monitor", G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) ((___lambda8__gbus_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda8__gbus_acquired_callback, NULL, (GClosureNotify) NULL)), (GClosure*) ((___lambda9__gbus_name_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda9__gbus_name_acquired_callback, NULL, (GClosureNotify) NULL)), (GClosure*) ((___lambda10__gbus_name_lost_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda10__gbus_name_lost_callback, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref)));
	result = FALSE;
	return result;
}


static gboolean ___lambda7__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda7_ (self);
	return result;
}


static gint monitor_main (gchar** args, int args_length1) {
	gint result = 0;
	Block1Data* _data1_;
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	gint status = 0;
	gint _tmp9_ = 0;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GMainLoop* _tmp12_;
	GMainLoop* _tmp13_;
	GError * _inner_error_ = NULL;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	deja_dup_i18n_setup ();
	g_set_application_name (_ ("Backup Monitor"));
	_tmp0_ = g_option_context_new ("");
	context = _tmp0_;
	_tmp1_ = context;
	g_option_context_add_main_entries (_tmp1_, MONITOR_options, GETTEXT_PACKAGE);
	{
		GOptionContext* _tmp2_;
		_tmp2_ = context;
		g_option_context_parse (_tmp2_, &args_length1, &args, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		GOptionContext* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		_tmp5_ = context;
		_tmp6_ = g_option_context_get_help (_tmp5_, TRUE, NULL);
		_tmp7_ = _tmp6_;
		g_printerr ("%s\n\n%s", _tmp4_, _tmp7_);
		_g_free0 (_tmp7_);
		result = 1;
		_g_error_free0 (e);
		_g_option_context_free0 (context);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return result;
	}
	__finally2:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp8_ = 0;
		_g_option_context_free0 (context);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp8_;
	}
	_tmp10_ = monitor_handle_options (&_tmp9_);
	status = _tmp9_;
	if (!_tmp10_) {
		result = status;
		_g_option_context_free0 (context);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return result;
	}
	_tmp11_ = deja_dup_initialize (NULL, NULL);
	if (!_tmp11_) {
		result = 1;
		_g_option_context_free0 (context);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return result;
	}
	_tmp12_ = g_main_loop_new (NULL, FALSE);
	_data1_->loop = _tmp12_;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda7__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	_tmp13_ = _data1_->loop;
	g_main_loop_run (_tmp13_);
	result = 0;
	_g_option_context_free0 (context);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}


int main (int argc, char ** argv) {
	return monitor_main (argv, argc);
}


Monitor* monitor_construct (GType object_type) {
	Monitor * self = NULL;
	self = (Monitor*) g_object_new (object_type, NULL);
	return self;
}


Monitor* monitor_new (void) {
	return monitor_construct (TYPE_MONITOR);
}


static void monitor_class_init (MonitorClass * klass) {
	monitor_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = monitor_finalize;
}


static void monitor_instance_init (Monitor * self) {
}


static void monitor_finalize (GObject * obj) {
	Monitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MONITOR, Monitor);
	G_OBJECT_CLASS (monitor_parent_class)->finalize (obj);
}


GType monitor_get_type (void) {
	static volatile gsize monitor_type_id__volatile = 0;
	if (g_once_init_enter (&monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Monitor), 0, (GInstanceInitFunc) monitor_instance_init, NULL };
		GType monitor_type_id;
		monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "Monitor", &g_define_type_info, 0);
		g_once_init_leave (&monitor_type_id__volatile, monitor_type_id);
	}
	return monitor_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



