/* DirHandling.c generated by valac 0.38.1, the Vala compiler
 * generated from DirHandling.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



gchar* deja_dup_get_trash_path (void);
gchar* deja_dup_parse_keywords (const gchar* dir);
GFile* deja_dup_parse_dir (const gchar* dir);
GFile** deja_dup_parse_dir_list (const gchar** dirs, int dirs_length1, int* result_length1);
static void _vala_array_add1 (GFile** * array, int* length, int* size, GFile* value);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


gchar* deja_dup_get_trash_path (void) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = g_get_user_data_dir ();
	_tmp1_ = g_build_filename (_tmp0_, "Trash", NULL);
	result = _tmp1_;
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = old;
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = old;
		_tmp4_ = replacement;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (self);
		result = _tmp5_;
		return result;
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = old;
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		regex = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp12_ = regex;
		_tmp13_ = replacement;
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
		_tmp11_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp15_ = _tmp11_;
		_tmp11_ = NULL;
		result = _tmp15_;
		_g_free0 (_tmp11_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* deja_dup_parse_keywords (const gchar* dir) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** dirs = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gint dirs_length1;
	gint _dirs_size_;
	GUserDirectory* enums = NULL;
	GUserDirectory* _tmp11_;
	gint enums_length1;
	gint _enums_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	GUserDirectory* _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	gboolean _tmp15_;
	const gchar* _tmp46_;
	const gchar* _tmp47_;
	gchar* _tmp48_;
	gboolean _tmp49_ = FALSE;
	const gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gboolean _tmp53_;
	g_return_val_if_fail (dir != NULL, NULL);
	_tmp0_ = dir;
	_tmp1_ = g_strdup (_tmp0_);
	_result_ = _tmp1_;
	_tmp2_ = g_strdup ("$DESKTOP");
	_tmp3_ = g_strdup ("$DOCUMENTS");
	_tmp4_ = g_strdup ("$DOWNLOAD");
	_tmp5_ = g_strdup ("$MUSIC");
	_tmp6_ = g_strdup ("$PICTURES");
	_tmp7_ = g_strdup ("$PUBLIC_SHARE");
	_tmp8_ = g_strdup ("$TEMPLATES");
	_tmp9_ = g_strdup ("$VIDEOS");
	_tmp10_ = g_new0 (gchar*, 8 + 1);
	_tmp10_[0] = _tmp2_;
	_tmp10_[1] = _tmp3_;
	_tmp10_[2] = _tmp4_;
	_tmp10_[3] = _tmp5_;
	_tmp10_[4] = _tmp6_;
	_tmp10_[5] = _tmp7_;
	_tmp10_[6] = _tmp8_;
	_tmp10_[7] = _tmp9_;
	dirs = _tmp10_;
	dirs_length1 = 8;
	_dirs_size_ = dirs_length1;
	_tmp11_ = g_new0 (GUserDirectory, 8);
	_tmp11_[0] = G_USER_DIRECTORY_DESKTOP;
	_tmp11_[1] = G_USER_DIRECTORY_DOCUMENTS;
	_tmp11_[2] = G_USER_DIRECTORY_DOWNLOAD;
	_tmp11_[3] = G_USER_DIRECTORY_MUSIC;
	_tmp11_[4] = G_USER_DIRECTORY_PICTURES;
	_tmp11_[5] = G_USER_DIRECTORY_PUBLIC_SHARE;
	_tmp11_[6] = G_USER_DIRECTORY_TEMPLATES;
	_tmp11_[7] = G_USER_DIRECTORY_VIDEOS;
	enums = _tmp11_;
	enums_length1 = 8;
	_enums_size_ = enums_length1;
	_tmp12_ = dirs;
	_tmp12__length1 = dirs_length1;
	_tmp13_ = enums;
	_tmp13__length1 = enums_length1;
	_vala_assert (_tmp12__length1 == _tmp13__length1, "dirs.length == enums.length");
	_tmp14_ = _result_;
	_tmp15_ = g_str_has_prefix (_tmp14_, "$HOME");
	if (_tmp15_) {
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp16_ = _result_;
		_tmp17_ = g_get_home_dir ();
		_tmp18_ = string_replace (_tmp16_, "$HOME", _tmp17_);
		_g_free0 (_result_);
		_result_ = _tmp18_;
	} else {
		const gchar* _tmp19_;
		gboolean _tmp20_;
		_tmp19_ = _result_;
		_tmp20_ = g_str_has_prefix (_tmp19_, "$TRASH");
		if (_tmp20_) {
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			_tmp21_ = _result_;
			_tmp22_ = deja_dup_get_trash_path ();
			_tmp23_ = _tmp22_;
			_tmp24_ = string_replace (_tmp21_, "$TRASH", _tmp23_);
			_g_free0 (_result_);
			_result_ = _tmp24_;
			_g_free0 (_tmp23_);
		} else {
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp25_ = FALSE;
					_tmp25_ = TRUE;
					while (TRUE) {
						gint _tmp27_;
						gchar** _tmp28_;
						gint _tmp28__length1;
						const gchar* _tmp29_;
						gchar** _tmp30_;
						gint _tmp30__length1;
						gint _tmp31_;
						const gchar* _tmp32_;
						gboolean _tmp33_;
						if (!_tmp25_) {
							gint _tmp26_;
							_tmp26_ = i;
							i = _tmp26_ + 1;
						}
						_tmp25_ = FALSE;
						_tmp27_ = i;
						_tmp28_ = dirs;
						_tmp28__length1 = dirs_length1;
						if (!(_tmp27_ < _tmp28__length1)) {
							break;
						}
						_tmp29_ = _result_;
						_tmp30_ = dirs;
						_tmp30__length1 = dirs_length1;
						_tmp31_ = i;
						_tmp32_ = _tmp30_[_tmp31_];
						_tmp33_ = g_str_has_prefix (_tmp29_, _tmp32_);
						if (_tmp33_) {
							gchar* replacement = NULL;
							GUserDirectory* _tmp34_;
							gint _tmp34__length1;
							gint _tmp35_;
							GUserDirectory _tmp36_;
							const gchar* _tmp37_;
							gchar* _tmp38_;
							const gchar* _tmp39_;
							_tmp34_ = enums;
							_tmp34__length1 = enums_length1;
							_tmp35_ = i;
							_tmp36_ = _tmp34_[_tmp35_];
							_tmp37_ = g_get_user_special_dir (_tmp36_);
							_tmp38_ = g_strdup (_tmp37_);
							replacement = _tmp38_;
							_tmp39_ = replacement;
							if (_tmp39_ != NULL) {
								const gchar* _tmp40_;
								gchar** _tmp41_;
								gint _tmp41__length1;
								gint _tmp42_;
								const gchar* _tmp43_;
								const gchar* _tmp44_;
								gchar* _tmp45_;
								_tmp40_ = _result_;
								_tmp41_ = dirs;
								_tmp41__length1 = dirs_length1;
								_tmp42_ = i;
								_tmp43_ = _tmp41_[_tmp42_];
								_tmp44_ = replacement;
								_tmp45_ = string_replace (_tmp40_, _tmp43_, _tmp44_);
								_g_free0 (_result_);
								_result_ = _tmp45_;
							}
							_g_free0 (replacement);
							break;
						}
					}
				}
			}
		}
	}
	_tmp46_ = _result_;
	_tmp47_ = g_get_user_name ();
	_tmp48_ = string_replace (_tmp46_, "$USER", _tmp47_);
	_g_free0 (_result_);
	_result_ = _tmp48_;
	_tmp50_ = _result_;
	_tmp51_ = g_uri_parse_scheme (_tmp50_);
	_tmp52_ = _tmp51_;
	_tmp53_ = _tmp52_ == NULL;
	_g_free0 (_tmp52_);
	if (_tmp53_) {
		const gchar* _tmp54_;
		gboolean _tmp55_;
		_tmp54_ = _result_;
		_tmp55_ = g_path_is_absolute (_tmp54_);
		_tmp49_ = !_tmp55_;
	} else {
		_tmp49_ = FALSE;
	}
	if (_tmp49_) {
		const gchar* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		_tmp56_ = g_get_home_dir ();
		_tmp57_ = _result_;
		_tmp58_ = g_build_filename (_tmp56_, _tmp57_, NULL);
		_g_free0 (_result_);
		_result_ = _tmp58_;
	}
	result = _result_;
	enums = (g_free (enums), NULL);
	dirs = (_vala_array_free (dirs, dirs_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


GFile* deja_dup_parse_dir (const gchar* dir) {
	GFile* result = NULL;
	gchar* _result_ = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (dir != NULL, NULL);
	_tmp0_ = dir;
	_tmp1_ = deja_dup_parse_keywords (_tmp0_);
	_result_ = _tmp1_;
	_tmp2_ = _result_;
	if (_tmp2_ != NULL) {
		const gchar* _tmp3_;
		GFile* _tmp4_;
		_tmp3_ = _result_;
		_tmp4_ = g_file_parse_name (_tmp3_);
		result = _tmp4_;
		_g_free0 (_result_);
		return result;
	} else {
		result = NULL;
		_g_free0 (_result_);
		return result;
	}
	_g_free0 (_result_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _vala_array_add1 (GFile** * array, int* length, int* size, GFile* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFile*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


GFile** deja_dup_parse_dir_list (const gchar** dirs, int dirs_length1, int* result_length1) {
	GFile** result = NULL;
	GFile** rv = NULL;
	GFile** _tmp0_;
	gint rv_length1;
	gint _rv_size_;
	const gchar** _tmp1_;
	gint _tmp1__length1;
	GFile** _tmp9_;
	gint _tmp9__length1;
	_tmp0_ = g_new0 (GFile*, 0 + 1);
	rv = _tmp0_;
	rv_length1 = 0;
	_rv_size_ = rv_length1;
	_tmp1_ = dirs;
	_tmp1__length1 = dirs_length1;
	{
		const gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp1_;
		s_collection_length1 = _tmp1__length1;
		for (s_it = 0; s_it < _tmp1__length1; s_it = s_it + 1) {
			gchar* _tmp2_;
			gchar* s = NULL;
			_tmp2_ = g_strdup ((gchar*) s_collection[s_it]);
			s = _tmp2_;
			{
				GFile* f = NULL;
				const gchar* _tmp3_;
				GFile* _tmp4_;
				GFile* _tmp5_;
				_tmp3_ = s;
				_tmp4_ = deja_dup_parse_dir (_tmp3_);
				f = _tmp4_;
				_tmp5_ = f;
				if (_tmp5_ != NULL) {
					GFile** _tmp6_;
					gint _tmp6__length1;
					GFile* _tmp7_;
					GFile* _tmp8_;
					_tmp6_ = rv;
					_tmp6__length1 = rv_length1;
					_tmp7_ = f;
					_tmp8_ = _g_object_ref0 (_tmp7_);
					_vala_array_add1 (&rv, &rv_length1, &_rv_size_, _tmp8_);
				}
				_g_object_unref0 (f);
				_g_free0 (s);
			}
		}
	}
	_tmp9_ = rv;
	_tmp9__length1 = rv_length1;
	if (result_length1) {
		*result_length1 = _tmp9__length1;
	}
	result = _tmp9_;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



