/* WidgetUtils.c generated by valac 0.38.1, the Vala compiler
 * generated from WidgetUtils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include "deja.h"

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define DEJA_DUP_TYPE_SHELL_ENV (deja_dup_shell_env_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;

typedef enum  {
	DEJA_DUP_SHELL_ENV_NONE,
	DEJA_DUP_SHELL_ENV_GNOME,
	DEJA_DUP_SHELL_ENV_LEGACY
} DejaDupShellEnv;

struct _Block3Data {
	int _ref_count_;
	GtkWidget* w;
};


extern DejaDupShellEnv deja_dup_shell;
DejaDupShellEnv deja_dup_shell = DEJA_DUP_SHELL_ENV_NONE;

void deja_dup_show_uri (GtkWindow* parent, const gchar* link);
void deja_dup_destroy_widget (GtkWidget* w);
GType deja_dup_shell_env_get_type (void) G_GNUC_CONST;
DejaDupShellEnv deja_dup_get_shell (void);
gboolean deja_dup_user_focused (GtkWidget* win, GdkEventFocus* e);
static gboolean _deja_dup_user_focused_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
void deja_dup_show_background_window_for_shell (GtkWindow* win);
void deja_dup_hide_background_window_for_shell (GtkWindow* win);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block3Data* _data3_);
static gboolean ___lambda5__gsource_func (gpointer self);
gboolean deja_dup_gui_initialize (GtkWindow* parent, gboolean show_error);


void deja_dup_show_uri (GtkWindow* parent, const gchar* link) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (link != NULL);
	{
		GtkWindow* _tmp0_;
		const gchar* _tmp1_;
		guint32 _tmp2_;
		_tmp0_ = parent;
		_tmp1_ = link;
		_tmp2_ = gtk_get_current_event_time ();
		gtk_show_uri_on_window (_tmp0_, _tmp1_, _tmp2_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GtkMessageDialog* dlg = NULL;
		GtkWindow* _tmp3_;
		const gchar* _tmp4_;
		GtkMessageDialog* _tmp5_;
		GtkMessageDialog* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GtkMessageDialog* _tmp9_;
		GtkMessageDialog* _tmp10_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = parent;
		_tmp4_ = link;
		_tmp5_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp3_, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, _ ("Could not display %s"), _tmp4_);
		g_object_ref_sink (_tmp5_);
		dlg = _tmp5_;
		_tmp6_ = dlg;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		gtk_message_dialog_format_secondary_text (_tmp6_, "%s", _tmp8_);
		_tmp9_ = dlg;
		gtk_dialog_run ((GtkDialog*) _tmp9_);
		_tmp10_ = dlg;
		deja_dup_destroy_widget ((GtkWidget*) _tmp10_);
		_g_object_unref0 (dlg);
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


GType deja_dup_shell_env_get_type (void) {
	static volatile gsize deja_dup_shell_env_type_id__volatile = 0;
	if (g_once_init_enter (&deja_dup_shell_env_type_id__volatile)) {
		static const GEnumValue values[] = {{DEJA_DUP_SHELL_ENV_NONE, "DEJA_DUP_SHELL_ENV_NONE", "none"}, {DEJA_DUP_SHELL_ENV_GNOME, "DEJA_DUP_SHELL_ENV_GNOME", "gnome"}, {DEJA_DUP_SHELL_ENV_LEGACY, "DEJA_DUP_SHELL_ENV_LEGACY", "legacy"}, {0, NULL, NULL}};
		GType deja_dup_shell_env_type_id;
		deja_dup_shell_env_type_id = g_enum_register_static ("DejaDupShellEnv", values);
		g_once_init_leave (&deja_dup_shell_env_type_id__volatile, deja_dup_shell_env_type_id);
	}
	return deja_dup_shell_env_type_id__volatile;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


DejaDupShellEnv deja_dup_get_shell (void) {
	DejaDupShellEnv result = 0;
	DejaDupShellEnv _tmp0_;
	DejaDupShellEnv _tmp6_;
	_tmp0_ = deja_dup_shell;
	if (_tmp0_ == DEJA_DUP_SHELL_ENV_NONE) {
		gchar* desktop = NULL;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		DejaDupShellEnv _tmp3_ = 0;
		const gchar* _tmp4_;
		gboolean _tmp5_;
		_tmp1_ = g_getenv ("XDG_CURRENT_DESKTOP");
		_tmp2_ = g_strdup (_tmp1_);
		desktop = _tmp2_;
		_tmp4_ = desktop;
		_tmp5_ = string_contains (_tmp4_, "GNOME");
		if (_tmp5_) {
			_tmp3_ = DEJA_DUP_SHELL_ENV_GNOME;
		} else {
			_tmp3_ = DEJA_DUP_SHELL_ENV_LEGACY;
		}
		deja_dup_shell = _tmp3_;
		_g_free0 (desktop);
	}
	_tmp6_ = deja_dup_shell;
	result = _tmp6_;
	return result;
}


static gboolean _deja_dup_user_focused_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = deja_dup_user_focused (_sender, event);
	return result;
}


gboolean deja_dup_user_focused (GtkWidget* win, GdkEventFocus* e) {
	gboolean result = FALSE;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	guint _tmp2_;
	g_return_val_if_fail (win != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = win;
	gtk_window_set_urgency_hint (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow), FALSE);
	_tmp1_ = win;
	g_signal_parse_name ("focus-in-event", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _deja_dup_user_focused_gtk_widget_focus_in_event, NULL);
	result = FALSE;
	return result;
}


void deja_dup_show_background_window_for_shell (GtkWindow* win) {
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp3_;
	g_return_if_fail (win != NULL);
	_tmp0_ = win;
	gtk_window_set_focus_on_map (_tmp0_, FALSE);
	_tmp1_ = win;
	gtk_window_set_urgency_hint (_tmp1_, TRUE);
	_tmp2_ = win;
	g_signal_connect ((GtkWidget*) _tmp2_, "focus-in-event", (GCallback) _deja_dup_user_focused_gtk_widget_focus_in_event, NULL);
	_tmp3_ = win;
	gtk_widget_show ((GtkWidget*) _tmp3_);
}


void deja_dup_hide_background_window_for_shell (GtkWindow* win) {
	GtkWindow* _tmp0_;
	g_return_if_fail (win != NULL);
	_tmp0_ = win;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		_g_object_unref0 (_data3_->w);
		g_slice_free (Block3Data, _data3_);
	}
}


static gboolean __lambda5_ (Block3Data* _data3_) {
	gboolean result = FALSE;
	GtkWidget* _tmp0_;
	_tmp0_ = _data3_->w;
	gtk_widget_destroy (_tmp0_);
	result = FALSE;
	return result;
}


static gboolean ___lambda5__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda5_ (self);
	return result;
}


void deja_dup_destroy_widget (GtkWidget* w) {
	Block3Data* _data3_;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	g_return_if_fail (w != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_tmp0_ = w;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data3_->w);
	_data3_->w = _tmp1_;
	_tmp2_ = _data3_->w;
	gtk_widget_hide (_tmp2_);
	_tmp3_ = _data3_->w;
	g_object_ref ((GObject*) _tmp3_);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda5__gsource_func, block3_data_ref (_data3_), block3_data_unref);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}


gboolean deja_dup_gui_initialize (GtkWindow* parent, gboolean show_error) {
	gboolean result = FALSE;
	gchar* header = NULL;
	gchar* msg = NULL;
	gboolean rv = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	_tmp2_ = deja_dup_initialize (&_tmp0_, &_tmp1_);
	_g_free0 (header);
	header = _tmp0_;
	_g_free0 (msg);
	msg = _tmp1_;
	rv = _tmp2_;
	_tmp4_ = rv;
	if (!_tmp4_) {
		gboolean _tmp5_;
		_tmp5_ = show_error;
		_tmp3_ = _tmp5_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GtkMessageDialog* dlg = NULL;
		GtkWindow* _tmp6_;
		const gchar* _tmp7_;
		GtkMessageDialog* _tmp8_;
		GtkMessageDialog* _tmp9_;
		const gchar* _tmp10_;
		GtkMessageDialog* _tmp11_;
		GtkMessageDialog* _tmp12_;
		_tmp6_ = parent;
		_tmp7_ = header;
		_tmp8_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp6_, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", _tmp7_);
		g_object_ref_sink (_tmp8_);
		dlg = _tmp8_;
		_tmp9_ = dlg;
		_tmp10_ = msg;
		gtk_message_dialog_format_secondary_text (_tmp9_, "%s", _tmp10_);
		_tmp11_ = dlg;
		gtk_dialog_run ((GtkDialog*) _tmp11_);
		_tmp12_ = dlg;
		deja_dup_destroy_widget ((GtkWidget*) _tmp12_);
		_g_object_unref0 (dlg);
	}
	result = rv;
	_g_free0 (msg);
	_g_free0 (header);
	return result;
}



